//=============================================================================
// ReplacePictureName.js
// ----------------------------------------------------------------------------
// <利用規約>
//  利用はRPGツクールMV/RPGMakerMVの正規ユーザーに限られます。
//  商用、非商用、ゲームの内容を問わず利用可能です。
//  ゲームへの利用の際、報告や出典元の記載等は必須ではありません。
//  二次配布や転載は禁止します。
//  ソースコードURL、ダウンロードURLへの直接リンクも禁止します。
//  不具合対応以外のサポートやリクエストは受け付けておりません。
//  スクリプト利用により生じたいかなる問題においても、一切責任を負いかねます。
// ----------------------------------------------------------------------------
//  Ver1.00  2016/01/24  初版
//  Ver1.01  2019/12/28  ツクールMV最新版対応
//=============================================================================

/*:
 * @plugindesc 画像、音声、動画読み込み時、指定された名前を任意の名前に置き換えて読み込むようにします。
 * @author こま
 *
 * @help 使い方については、プラグインに同梱されているドキュメントをご参照ください。
 */

(function(){
    var ReplaceNameList = { 
        img:{ 
            "img/characters/!$サキュバスドッド.png":"img/characters/Material0001.png", 
            "img/characters/3子供女性01.png":"img/characters/Material0002.png", 
            "img/characters/3子供女性02.png":"img/characters/Material0003.png", 
            "img/characters/3子供女性03.png":"img/characters/Material0004.png", 
            "img/characters/3子供女性04.png":"img/characters/Material0005.png", 
            "img/characters/3子供男性01.png":"img/characters/Material0006.png", 
            "img/characters/3子供男性02.png":"img/characters/Material0007.png", 
            "img/characters/3子供男性03.png":"img/characters/Material0008.png", 
            "img/characters/3子供男性04.png":"img/characters/Material0009.png", 
            "img/characters/バニー＆子ども妖精.png":"img/characters/Material0010.png", 
            "img/characters/メイド＆執事 - コピー.png":"img/characters/Material0011.png", 
            "img/characters/メイド＆執事.png":"img/characters/Material0012.png", 
            "img/faces/シスターテスト.png":"img/faces/Material0013.png", 
            "img/faces/ペド.png":"img/faces/Material0014.png", 
            "img/faces/メイドボーイッシュアイコン.png":"img/faces/Material0015.png", 
            "img/faces/メイド地味アイコン.png":"img/faces/Material0016.png", 
            "img/faces/メイド長アイコン.png":"img/faces/Material0017.png", 
            "img/faces/ヤンキバニーアイコン.png":"img/faces/Material0018.png", 
            "img/faces/ユニコーン用.png":"img/faces/Material0019.png", 
            "img/faces/ユニコーン用1.png":"img/faces/Material0020.png", 
            "img/faces/ロリお嬢様.png":"img/faces/Material0021.png", 
            "img/faces/馬ニュコ.png":"img/faces/Material0022.png", 
            "img/pictures/エネマジラ射精.png":"img/pictures/Material0023.png", 
            "img/pictures/サキュバス1のみ.png":"img/pictures/Material0024.png", 
            "img/pictures/サキュバス1のみ舌.png":"img/pictures/Material0025.png", 
            "img/pictures/サキュバス1射精.png":"img/pictures/Material0026.png", 
            "img/pictures/サキュバス1射精デフォ.png":"img/pictures/Material0027.png", 
            "img/pictures/サキュバス1舌出し.png":"img/pictures/Material0028.png", 
            "img/pictures/サキュバス1挿入.png":"img/pictures/Material0029.png", 
            "img/pictures/サキュバス1挿入直前.png":"img/pictures/Material0030.png", 
            "img/pictures/サキュバス1目つむり.png":"img/pictures/Material0031.png", 
            "img/pictures/サキュバス1目つむり舌射精.png":"img/pictures/Material0032.png", 
            "img/pictures/シスターチンあり口開き.png":"img/pictures/Material0033.png", 
            "img/pictures/シスターチンあり真顔.png":"img/pictures/Material0034.png", 
            "img/pictures/シスター机のみ口開き.png":"img/pictures/Material0035.png", 
            "img/pictures/シスター射精口開き.png":"img/pictures/Material0036.png", 
            "img/pictures/シスター射精真顔.png":"img/pictures/Material0037.png", 
            "img/pictures/シスター真顔机のみ.png":"img/pictures/Material0038.png", 
            "img/pictures/シスター片目つむり.png":"img/pictures/Material0039.png", 
            "img/pictures/シスター片目つむり射精.png":"img/pictures/Material0040.png", 
            "img/pictures/ニュコおしっこ口開き.png":"img/pictures/Material0041.png", 
            "img/pictures/ニュコおしっこ出てる.png":"img/pictures/Material0042.png", 
            "img/pictures/ニュコおしっこ出てる口開き.png":"img/pictures/Material0043.png", 
            "img/pictures/ニュコおしっこ前.png":"img/pictures/Material0044.png", 
            "img/pictures/ニュコレイプきもちいい.png":"img/pictures/Material0045.png", 
            "img/pictures/ニュコレイプ最初.png":"img/pictures/Material0046.png", 
            "img/pictures/ニュコレイプ射精.png":"img/pictures/Material0047.png", 
            "img/pictures/ニュコレイプ絶頂.png":"img/pictures/Material0048.png", 
            "img/pictures/ニュコレイプ挿入.png":"img/pictures/Material0049.png", 
            "img/pictures/ニュコ耳舐め舌無し.png":"img/pictures/Material0050.png", 
            "img/pictures/ニュコ手コキ.png":"img/pictures/Material0051.png", 
            "img/pictures/ニュコ手コキ射精.png":"img/pictures/Material0052.png", 
            "img/pictures/ニュコ素股１.png":"img/pictures/Material0053.png", 
            "img/pictures/ニュコ素股２.jpg":"img/pictures/Material0054.jpg", 
            "img/pictures/ニュコ素股2.png":"img/pictures/Material0055.png", 
            "img/pictures/ニュコ素股感じてる.png":"img/pictures/Material0056.png", 
            "img/pictures/ニュコ素股感じてる射精.png":"img/pictures/Material0057.png", 
            "img/pictures/ニュコ素股最初.png":"img/pictures/Material0058.png", 
            "img/pictures/ニュコ素股射精.png":"img/pictures/Material0059.png", 
            "img/pictures/ニュコ素股笑顔.png":"img/pictures/Material0060.png", 
            "img/pictures/ニュコ足コキ.png":"img/pictures/Material0061.png", 
            "img/pictures/ニュコ足コキちんちん無し.png":"img/pictures/Material0062.png", 
            "img/pictures/ニュコ足コキ強気.png":"img/pictures/Material0063.png", 
            "img/pictures/ニュコ足コキ困り笑顔.png":"img/pictures/Material0064.png", 
            "img/pictures/ニュコ足コキ困り笑顔射精.png":"img/pictures/Material0065.png", 
            "img/pictures/ニュコ足コキ責め顔.png":"img/pictures/Material0066.png", 
            "img/pictures/ニュコ足コキ責め顔射精.png":"img/pictures/Material0067.png", 
            "img/pictures/ニュコ足コキ怒り.png":"img/pictures/Material0068.png", 
            "img/pictures/ニュコ立ち絵.png":"img/pictures/Material0069.png", 
            "img/pictures/ニュコ立ち絵ギャグ不満.png":"img/pictures/Material0070.png", 
            "img/pictures/ニュコ立ち絵きょとん.png":"img/pictures/Material0071.png", 
            "img/pictures/ニュコ立ち絵たくらみ顔.png":"img/pictures/Material0072.png", 
            "img/pictures/ニュコ立ち絵デフォ.png":"img/pictures/Material0073.png", 
            "img/pictures/ニュコ立ち絵ハート目.png":"img/pictures/Material0074.png", 
            "img/pictures/ニュコ立ち絵びっくり.png":"img/pictures/Material0075.png", 
            "img/pictures/ニュコ立ち絵びっくり裸.png":"img/pictures/Material0076.png", 
            "img/pictures/ニュコ立ち絵笑顔.png":"img/pictures/Material0077.png", 
            "img/pictures/ニュコ立ち絵赤面.png":"img/pictures/Material0078.png", 
            "img/pictures/ニュコ立ち絵赤面全裸.png":"img/pictures/Material0079.png", 
            "img/pictures/ニュコ立ち絵悲しい.png":"img/pictures/Material0080.png", 
            "img/pictures/ニュコ立ち絵不満顔.png":"img/pictures/Material0081.png", 
            "img/pictures/バニーニュコ表情.png":"img/pictures/Material0082.png", 
            "img/pictures/バニーニュコ表情たくらみ.png":"img/pictures/Material0083.png", 
            "img/pictures/バニーニュコ表情デフォ.png":"img/pictures/Material0084.png", 
            "img/pictures/バニーニュコ表情ハート.png":"img/pictures/Material0085.png", 
            "img/pictures/バニーニュコ表情照れ.png":"img/pictures/Material0086.png", 
            "img/pictures/バニーニュコ表情笑顔.png":"img/pictures/Material0087.png", 
            "img/pictures/バニーニュコ表情不満.png":"img/pictures/Material0088.png", 
            "img/pictures/ボイメイド.png":"img/pictures/Material0089.png", 
            "img/pictures/メイド隙間光.png":"img/pictures/Material0090.png", 
            "img/pictures/メイド黒フレーム.png":"img/pictures/Material0091.png", 
            "img/pictures/メイド長.png":"img/pictures/Material0092.png", 
            "img/pictures/ルゥニュコフェラ1.png":"img/pictures/Material0093.png", 
            "img/pictures/ルゥニュコフェラ2.png":"img/pictures/Material0094.png", 
            "img/pictures/ルゥニュコフェラ3.png":"img/pictures/Material0095.png", 
            "img/pictures/ルゥニュコフェラ4.png":"img/pictures/Material0096.png", 
            "img/pictures/ルゥニュコフェラ5.png":"img/pictures/Material0097.png", 
            "img/pictures/ロリニュコクンニ.png":"img/pictures/Material0098.png", 
            "img/pictures/ロリニュコクンニ1.png":"img/pictures/Material0099.png", 
            "img/pictures/ロリニュコクンニ2.png":"img/pictures/Material0100.png", 
            "img/pictures/ロリフェラ１.png":"img/pictures/Material0101.png", 
            "img/pictures/ロリフェラ２.png":"img/pictures/Material0102.png", 
            "img/pictures/ロリフェラ３.png":"img/pictures/Material0103.png", 
            "img/pictures/ロリフェラちんこだけ.png":"img/pictures/Material0104.png", 
            "img/pictures/眼鏡メイド.png":"img/pictures/Material0105.png", 
            "img/pictures/眼鏡メイド２.png":"img/pictures/Material0106.png", 
            "img/pictures/兄ニュコ騎乗位1.png":"img/pictures/Material0107.png", 
            "img/pictures/兄ニュコ騎乗位2.png":"img/pictures/Material0108.png", 
            "img/pictures/兄ニュコ騎乗位3.png":"img/pictures/Material0109.png", 
            "img/pictures/女児乳首チラきょとん.png":"img/pictures/Material0110.png", 
            "img/pictures/女児乳首チラ口閉じ.png":"img/pictures/Material0111.png", 
            "img/pictures/女児乳首チラ笑顔.png":"img/pictures/Material0112.png", 
            "img/pictures/人妻授乳手コキ.png":"img/pictures/Material0113.png", 
            "img/pictures/人妻授乳手コキニュコ.png":"img/pictures/Material0114.png", 
            "img/pictures/人妻授乳手コキニュコ射精.png":"img/pictures/Material0115.png", 
            "img/pictures/人妻風呂入り射精.png":"img/pictures/Material0116.png", 
            "img/pictures/立ち絵ニュコ触手.png":"img/pictures/Material0117.png", 
            "img/pictures/立ち絵ニュコ裸.png":"img/pictures/Material0118.png", 
            "img/pictures/立ち絵ニュコ裸たくらみ.png":"img/pictures/Material0119.png", 
            "img/sv_actors/サキュバスドッド.png":"img/sv_actors/Material0120.png", 
            "img/system/Window_デフォルト.png":"img/system/Material0121.png", 
            "img/titles1/ニュコスタート.png":"img/titles1/Material0122.png", 
        }, 
        audio:{ 
            "audio/bgm/FrenchPop_02ニュコ.ogg":"audio/bgm/Material0123.ogg", 
            "audio/bgm/MusMus-BGM-チャラい曲.ogg":"audio/bgm/Material0124.ogg", 
            "audio/bgm/つないだ手素股.ogg":"audio/bgm/Material0125.ogg", 
            "audio/bgm/つぼみ.ogg":"audio/bgm/Material0126.ogg", 
            "audio/bgm/ミルクティー.ogg":"audio/bgm/Material0127.ogg", 
            "audio/bgm/リピュア.ogg":"audio/bgm/Material0128.ogg", 
            "audio/bgm/子猫のエクササイズ.ogg":"audio/bgm/Material0129.ogg", 
            "audio/bgm/石化解けたMusMus-BGM-066.ogg":"audio/bgm/Material0130.ogg", 
            "audio/bgm/悲しいMusMus-BGM-144.ogg":"audio/bgm/Material0131.ogg", 
            "audio/bgm/変な人に注意.ogg":"audio/bgm/Material0132.ogg", 
            "audio/bgm/魔王魂 12345.ogg":"audio/bgm/Material0133.ogg", 
            "audio/se/ガチャガチャkey3.ogg":"audio/se/Material0134.ogg", 
            "audio/se/フェラ16（レロレロ）.ogg":"audio/se/Material0135.ogg", 
            "audio/se/フェラ21（高速）.ogg":"audio/se/Material0136.ogg", 
            "audio/se/フェラ3.ogg":"audio/se/Material0137.ogg", 
            "audio/se/ボロンッ.ogg":"audio/se/Material0138.ogg", 
            "audio/se/射精音.ogg":"audio/se/Material0139.ogg", 
            "audio/se/噴射系おしっこ７.ogg":"audio/se/Material0140.ogg", 
        }, 
        movies:{ 
        } 
    }; 

    
    var _Bitmap_load = Bitmap.load;
    Bitmap.load = function(url) {
        var _url = decodeURIComponent(url);
        if (ReplaceNameList.img.hasOwnProperty(_url)) {
            url = ReplaceNameList.img[_url];
        }
        return _Bitmap_load.call(this, url);
    };
    
    var _Bitmap_request = Bitmap.request;
    Bitmap.request = function(url) {
        var _url = decodeURIComponent(url);
        if (ReplaceNameList.img.hasOwnProperty(_url)) {
            url = ReplaceNameList.img[_url];
        }
        return _Bitmap_request.call(this, url);
    };
    
    var _Html5Audio_setup = Html5Audio.setup;
    Html5Audio.setup = function (url) {
        var _url = decodeURIComponent(url);
        if (ReplaceNameList.audio.hasOwnProperty(_url)) {
            url = ReplaceNameList.audio[_url];
        }
        _Html5Audio_setup.call(this, url);
    };

    var _WebAudio_initialize = WebAudio.prototype.initialize;
    WebAudio.prototype.initialize = function(url) {
        var _url = decodeURIComponent(url);
        if (ReplaceNameList.audio.hasOwnProperty(_url)) {
            url = ReplaceNameList.audio[_url];
        }
        _WebAudio_initialize.call(this, url);
    };
    
    var _Graphics_playVideo = Graphics.playVideo;
    Graphics.playVideo = function(src) {
        if (ReplaceNameList.movies.hasOwnProperty(src)) {
            src = ReplaceNameList.movies[src];
        }
        _Graphics_playVideo.call(this, src);
    };
}());
